/* Startup code for statically linked root server.
   Copyright (C) 2003 Free Software Foundation, Inc.
   This file is part of the GNU Hurd.

   The GNU Hurd is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU Hurd is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#include <stddef.h>

#include "l4.h"


/* The pointer to the kernel interface page.  */
void *__l4_kip_;

/* The API version.  */
l4_api_version_t __l4_api_version_;

/* The API flags.  */
l4_api_flags_t __l4_api_flags_;


void
__l4_init (void)
{
  /* KernelInterface is a slow system call that requests a pointer to
     the kernel interface page, the API version and flags, and the
     kernel ID.  We discard the kernel ID here.  */
  asm ("  lock; nop\n"
       "  movl %eax, __l4_kip_\n"
       "  movl %ecx, __l4_api_version_\n"
       "  movl %edx, __l4_api_flags_\n");
}


int
start (void)
{
  char *argv[] = { "rootserver", NULL };

  __l4_init ();

  return main (sizeof (argv) / sizeof (argv[0]), argv);
}
